﻿	extrn @Temporary@Byte
	cseg
Numbers_: ;Numbers
	defb 26
	defb 30
	defb 1
	defb 16
	defb 9
	defb 13
	defb 12
	defb 5
	defb 14
	defb 15
	defb 27
	defb 7
	defb 4
	defb 3
	defb 24
	defb 20
	defb 8
	defb 18
	defb 22
	defb 10
	defb 19
	defb 21
	defb 23
	defb 6
	defb 2
	defb 29
	defb 28
	defb 11
	defb 31
	defb 0
	defb 17
	defb 25
	dseg
RndIndex_:	defs 1
	public	RndIndex_
;
;	function Rnd
;

dseg
	defs 1 ; alignment
	dseg
	dseg
	;r => register al
	cseg
Rnd_:
	public	Rnd_
	push ax
	push bx
	;	@2 = (sword)RndIndex	[0]
	mov al,[RndIndex_]
	xor ah,ah
	;	@1 = @2 + Numbers_	[1]
	mov bx,ax
	add bx,Numbers_
	;	r = *@1	[2]
	mov al,[bx+0]
	;	RndIndex = RndIndex + 1	[3]
	inc byte ptr [RndIndex_]
	;	if RndIndex < 32 goto Rnd@Anchor5	[4]
	cmp byte ptr [RndIndex_],32
	jb Rnd@Anchor5
	;	RndIndex = 0	[5]
	mov byte ptr [RndIndex_],0
Rnd@Anchor5:
	;	@3 = r & 15	[6]
	and al,15
	;	return @3	[7]
Rnd@Anchor4:
	pop bx
	mov [@Temporary@Byte],al
	pop ax
	mov al,[@Temporary@Byte]
	ret
;
;	function Abs
;
	dseg
	;a => register cl
	;b => register dl
	cseg
Abs_:
	public	Abs_
	push ax
	push cx
	;	a = @1	[0]
	mov cl,al
	;	b = @2	[1]
	;	if a >= b goto Abs@Anchor7	[2]
	cmp cl,dl
	jae Abs@Anchor7
	;	@3 = b - a	[3]
	mov al,dl
	sub al,cl
	;	return @3	[4]
	jmp Abs@Anchor6
	;	goto Abs@Anchor8	[5]
	jmp Abs@Anchor8
Abs@Anchor7:
	;	@4 = a - b	[6]
	mov al,cl
	sub al,dl
	;	return @4	[7]
Abs@Anchor6:
Abs@Anchor8:
	pop cx
	mov [@Temporary@Byte],al
	pop ax
	mov al,[@Temporary@Byte]
	ret
;
;	function Sign
;
	dseg
	;from => register al
	;to => register dl
	cseg
Sign_:
	public	Sign_
	;	from = @1	[0]
	;	to = @2	[1]
	;	if from != to goto Sign@Anchor10	[2]
	cmp al,dl
	jne Sign@Anchor10
	;	return 0	[3]
	xor al,al
	jmp Sign@Anchor9
Sign@Anchor10:
	;	if from >= to goto Sign@Anchor11	[4]
	cmp al,dl
	jae Sign@Anchor11
	;	return 1	[5]
	mov al,1
	jmp Sign@Anchor9
Sign@Anchor11:
	;	return -1	[6]
	mov al,-1
Sign@Anchor9:
	ret
