include "wsc.inc"
include "Vram.inc"
include "VVram.inc"

ext VVram_

; void ClearScreen();
cseg
ClearScreen_:  public ClearScreen_
	push ax | push cx | push bx
        xor ax,ax
        mov bx,VramBack
        mov cx,32*32*2
        do
            mov [bx],ax | inc bx | inc bx
        wloop
    pop bx | pop cx | pop ax
ret


; word VramOffset(byte x, byte y);
cseg
VramOffset_: public VramOffset_
    push dx
        mov dh,al
            mov al,32
            mul dl
        mov dl,dh
        xor dh,dh
        add ax,dx
        add ax,ax
    pop dx
ret


; ptr<byte> Put(ptr<byte> pVram, word c);
cseg
Put_: public Put_
    push bx
        mov bx,ax
        mov [bx],dx
    pop bx
    inc ax | inc ax
ret


; void VVramToVram();
cseg
VVramToVram_: public VVramToVram_
    push cx | push si | push dx
        mov cx,ds | mov es,cx
        mov si,VVram_
        mov di,VramBackOrg
        xor ah,ah
        mov ch,VVramHeight
        do
            mov cl,VVramWidth
            do
                mov al,[si] | inc si
                mov [di],ax | inc di | inc di
                dec cl
            while nz | wend
            add di,VramRowSize-VVramWidth*VramStep
            dec ch
        while nz | wend
    pop di | pop si | pop cx
ret